searchNodes=[{"doc":"UsagePut require Blocked in your module to be able to use the exposed macro.Write Blocked.by(issue_reference, reason, do: ..., else: ...) wherever you have to apply a temporary fix.Example:defmodule Example do require Blocked def main do IO.puts(&quot;Hello, world!&quot;) Blocked.by(&quot;#42&quot;, &quot;This code can be removed when the issue is closed&quot;) do hacky_workaround() end # The reason is optional Blocked.by(&quot;#69&quot;) do a_quick_fix() end # It is possible to indicate # the desired &#39;ideal&#39; code as well, by passing an `else` block: Blocked.by(&quot;#1337&quot;) do ugly_fallback() else beautiful_progress() end # If the blockage is more general, you can also leave out the `do` block. Blocked.by(&quot;#65535&quot;, &quot;This whole module can be rewritten once we&#39;re on the new Elixir version!&quot;) # Blocked supports many ways of referring to an issue Blocked.by(&quot;#13&quot;) Blocked.by(&quot;elixir#13&quot;) Blocked.by(&quot;elixir/13&quot;) Blocked.by(&quot;elixir-lang/elixir#13&quot;) Blocked.by(&quot;elixir-lang/elixir/13&quot;) Blocked.by(&quot;https://github.com/elixir-lang/elixir/issues/13&quot;) end endWhen will Blocked.by/3 run?By default, the checks will only be performed inside Continuous Integration environments. (That is, any place where System.get_env(&quot;CI&quot;) is set). The reason for this default is that the checks perform HTTP requests to the GitHub-API, which will slow down compilation somewhat.This can be overridden by altering the warn-field in the Blocked.Config for a particular environment.What if I have a private GitHub-repository?By default, Blocked will run with an unauthenticated GitHub-client. You can configure the client by specifying an API token (of an account that has access to the repository in question) in the Blocked.Config.Supported Issue Reference patterns123 or #123: issue number. Assumes that the isue is part of the current repository.reponame/123 or reponame#123: repository + issue number. Assumes that the repository is part of the same owner/organization as the current repository.owner/reponame/123 or owner/reponame#123: owner/organization name + repository + issue number.https://github.com/owner/reponame/issues/123: Full-blown URL to the page of the issue.Automatic Repository DetectionWe use the git remote get-url command to check for the remote URL of the current repository and attempt to extract the owner/organization and repository name from that. We check against the upstream remote (useful in a forked project), and the origin remote.If your setup is different, you can configure the repository and owner name by specifying custom settings in the Blocked.Config.","ref":"Blocked.html","title":"Blocked","type":"module"},{"doc":"Prints a compile-time warning whenever the GitHub issue issue_reference is closed.This warning will contain the optional reason.General usageBlocked.by(issue_reference, reason) do # hotfix code here # ... else # ideal code here # ... endWhen the issue is open, will expand to the hotfix code in the do: ... block. This block can be used to indicate the code that is a 'temporary hotfix'. This block is optional (but recommended).When the issue is closed, will expand to the ideal code in the else: ... block. This block can be used to indicate the desired code that could be used once the hotfix is no longer necessary. This block is optional.If no else: ... is passed, we'll still expand to the do: ... block (since the hotfix should in that case work).See the module-documentation for more information on what format issue-references are supported, and on when Blocked.by is (and is not) run.Examples Only issue-referenceBlocked.by(&quot;some-repo/10&quot;) Blocked.by(&quot;some-other-repo#10&quot;) Issue-reference and reasonBlocked.by(&quot;some-repo/10&quot;, &quot;We need a special fetching function to support this.&quot;) Issue-reference, wrapping code (This is the recommended usage.)defmodule Foo do require Blocked def y_plus_x_squared(y, x) do Blocked.by(&quot;some-repo/10&quot;, &quot;Until a `pow` function exists, fall back to multiplication.&quot;) do y + (x * x) else y + pow(x, 2) end end end","ref":"Blocked.html#by/3","title":"Blocked.by/3","type":"macro"},{"doc":"Configuration for Blocked.The simplest ways to configure Blocked is by:adding config :blocked. [warn: true, project_owner: &quot;YourName&quot;] to your Elixir configuration file. (for older Elixir versions, this is Mix.Config; for newer versions, Config.)alternatively, adding system-environment-variables like BLOCKED_WARN=true, BLOCKED_PROJECT_OWNER=&quot;YourName&quot; etc. to the environment you want to run Blocked in.If you want to check the configuration in the current environment, print the output of Blocked.Config.load_with_defaults.More advanced configuration set-ups are possible by using the advanced features of Specify.Configuration structure documentation:This configuration was made using the Specify library. It contains the following fields:warntrigger warnings in this particular environment.When this is off, Blocked.by will simply silently compile to whatever block was passed.It is automatically turned on (by default) when we're in a Continuous Integration environment. (this is checked by looking for the prescence of the CI environment variable.)Validated/parsed by calling Specify.Parsers.term/1.(Specified as :term)Defaults to nil.project_repoThe repository name of this source-code project.This can be overridden if you cannot or don't want to rely on Blocked's auto-detection using the git command-line tools.Validated/parsed by calling Specify.Parsers.term/1.(Specified as :term)Defaults to nil.project_ownerThe name of the owner or organization of this source-code project.This can be overridden if you cannot or don't want to rely on Blocked's auto-detection using the git command-line tools.Validated/parsed by calling Specify.Parsers.term/1.(Specified as :term)Defaults to nil.github_api_tokenThis needs to be set if (and only if) you have a private GitHub-project, because otherwise we cannot access its issues.c.f. https://github.blog/2013-05-16-personal-api-tokens/Validated/parsed by calling Specify.Parsers.term/1.(Specified as :term)Defaults to nil.","ref":"Blocked.Config.html","title":"Blocked.Config","type":"module"},{"doc":"Loads, parses, and normalizes the configuration of Blocked.Config, based on the current source settings, returning the result as a struct.For more information about the options this function supports, see Specify.load/2 and Specify.Options","ref":"Blocked.Config.html#load/1","title":"Blocked.Config.load/1","type":"function"},{"doc":"Loads, parses and normalizes the configuration of Blocked.Config, using the provided explicit_values (and falling back to values configured elsewhere)For more information about the options this function supports, see Specify.load_explicit/3 and Specify.Options","ref":"Blocked.Config.html#load_explicit/2","title":"Blocked.Config.load_explicit/2","type":"function"},{"doc":"","ref":"Blocked.Config.html#load_with_defaults/0","title":"Blocked.Config.load_with_defaults/0","type":"function"},{"doc":"Blocked is an Elixir-library that helps you to keep track of when hotfixes can be removed by showing compile-time warnings when issues (in your project repository or any other source-code GitHub repository) are closed. Blocked was made to improve the quality of your project's code over time: It automates away the human task of checking whether certain hot-fixes, 'temporary patches' or 'duct-tape code' are still required. This makes it less scary to add a temporary workaround to your codebase, because you'll know the minute it is no longer necessary!Basic features:Runs at compile-time as a macro.Prints a compile-time warning any time an issue is closed that a piece of your code was waiting for.Works for your own project issues as well as for issues of any other GitHub-hosted repository.Allows specifying both 'hotfix' and optionally a 'desired' code block, to make it clear to future readers of your code what can be changed once the related issue is closed.Configurable to work on private repositories as well.By default performs only checking in Continuous Integration, to keep local compilation fast.InstallationThe package can be installed by adding blocked to your list of dependencies in mix.exs:def deps do [ {:blocked, &quot;~&gt; 0.9.0&quot;} ] endDocumentation can be found at https://hexdocs.pm/blocked.UsagePut require Blocked in your module to be able to use the exposed macro.Write Blocked.by(issue_reference, reason, do: ..., else: ...) wherever you have to apply a temporary fix.Example:defmodule Example do require Blocked def main do IO.puts(&quot;Hello, world!&quot;) Blocked.by(&quot;#42&quot;, &quot;This code can be removed when the issue is closed&quot;) do hacky_workaround() end # The reason is optional Blocked.by(&quot;#69&quot;) do a_quick_fix() end # It is possible to indicate # the desired &#39;ideal&#39; code as well, by passing an `else` block: Blocked.by(&quot;#1337&quot;) do ugly_fallback() else beautiful_progress() end # If the blockage is more general, you can also leave out the `do` block. Blocked.by(&quot;#65535&quot;, &quot;This whole module can be rewritten once we&#39;re on the new Elixir version!&quot;) # Blocked supports many ways of referring to an issue Blocked.by(&quot;#13&quot;) Blocked.by(&quot;elixir#13&quot;) Blocked.by(&quot;elixir/13&quot;) Blocked.by(&quot;elixir-lang/elixir#13&quot;) Blocked.by(&quot;elixir-lang/elixir/13&quot;) Blocked.by(&quot;https://github.com/elixir-lang/elixir/issues/13&quot;) end endAs example, a warning that might be generated once an issue is closeed looks like this:","ref":"readme.html","title":"Installation","type":"extras"},{"doc":"By default, the checks will only be performed inside Continuous Integration environments. (That is, any place where System.get_env(&quot;CI&quot;) is set). The reason for this default is that the checks perform HTTP requests to the GitHub-API, which will slow down compilation somewhat.This can be overridden by altering the warn-field in the Blocked.Config for a particular environment.","ref":"readme.html#when-will-blocked-by-run","title":"Installation - When will Blocked.by run?","type":"extras"},{"doc":"By default, Blocked will run with an unauthenticated GitHub-client. You can configure the client by specifying an API token (of an account that has access to the repository in question) in the Blocked.Config.","ref":"readme.html#what-if-i-have-a-private-github-repository","title":"Installation - What if I have a private GitHub-repository?","type":"extras"},{"doc":"123 or #123: issue number. Assumes that the isue is part of the current repository.reponame/123 or reponame#123: repository + issue number. Assumes that the repository is part of the same owner/organization as the current repository.owner/reponame/123 or owner/reponame#123: owner/organization name + repository + issue number.https://github.com/owner/reponame/issues/123: Full-blown URL to the page of the issue.","ref":"readme.html#supported-issue-reference-patterns","title":"Installation - Supported Issue Reference patterns","type":"extras"},{"doc":"We use the git remote get-url command to check for the remote URL of the current repository and attempt to extract the owner/organization and repository name from that. We check against the upstream remote (useful in a forked project), and the origin remote.If your setup is different, you can configure the repository and owner name by specifying custom settings in the Blocked.Config.Changelog0.9.1 - Fixes bug where HTTP was not always available at compile-time and improves stacktrace information.0.9.0 - Initial publicly-released versionRoadmap &amp; nice-to-havesPR's are very much accepted!Maybe at some point support GitLab, Bitbucket or other repository-hosts as well?AttributionThis library is inspired and borrows heavily from the Rust library of the same name.Is it any good?yes","ref":"readme.html#automatic-repository-detection","title":"Installation - Automatic Repository Detection","type":"extras"}]